#include <stdio.h>
#include "defs.h"

int fast_speed = 1;
int frame = 44100; 


long fast_rewind(tloopinfo *loop, tfileinfo *info){
	long curpos;

	if( (curpos=ftell(loop->fp)) >= 
				fast_speed*info->blkalign*info->srate + info->datastart ) {
		fseek(loop->fp,curpos-fast_speed*info->blkalign*info->srate,SEEK_SET);	
		return ((curpos - fast_speed*info->blkalign*info->srate) /info->blkalign);
	}
	else{
		if( fseek(loop->fp,info->datastart,SEEK_SET) != -1)	
			curpos = info->datastart;
			return (curpos/info->blkalign);
	}
	return (-1);
}
 
long fast_forward(tloopinfo *loop, tfileinfo *info){

	long curpos = 0;

	if(( (curpos = ftell(loop->fp)) <= (info->datalen - 
					fast_speed*info->blkalign*info->srate) )
			&&(curpos != -1)
			&&(info->datalen > fast_speed*info->blkalign*info->srate))
	{
		if ( fseek(loop->fp,curpos + fast_speed*info->blkalign*info->srate,SEEK_SET) != -1 )
		return ((curpos + fast_speed*info->blkalign*info->srate) 
								/info->blkalign);
		else
			return (-1);	
	}				
	return (-1);	
}

long set_start(tloopinfo *loop, tfileinfo *info){

	long curpos;

	if( ((curpos = ftell(loop->fp)) < loop->endpos*info->blkalign)
			&&(curpos != -1))
		return (curpos/info->blkalign);
	else
		return -1;
}

long set_end(tloopinfo *loop, tfileinfo *info){

	long curpos;

	if( ((curpos = ftell(loop->fp)) > loop->startpos*info->blkalign)&&(curpos != -1) )
		return (curpos/info->blkalign);
	else
		return -1;
}
long set_frame(tloopinfo *loop, tfileinfo *info){

	frame = (loop->endpos - loop->startpos) ;
	return (1);
}

long do_frame(tloopinfo *loop, tfileinfo *info){

	loop->endpos = frame + loop->startpos;
	return (1);
}

long go_home(tloopinfo *loop, tfileinfo *info){

	if( fseek( loop->fp, loop->startpos*info->blkalign, SEEK_SET ) == 0)
		return (loop->startpos);
	else
		return (-1);
}
