/***************************************************************************
***************************************************************************/
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/time.h>
#include <signal.h> 
#include "defs.h"
#include "file.h"
#include "dsp.h"
#include "snuggles.h"
#include "interface.h"

/***************************************************************************
*
***************************************************************************/
#define SO_TT_SIZE 2

#define MAXSTRING 1000

tsong *recsong = NULL;
char path[256];
char name[18];
pthread_t pid;
pthread_t tid;
int playno;

char *fullpath[MAX_SONGS];

void *set_file_path(int sam_no,char *filename)
{
	char *pathname;
	pathname=malloc(strlen(sample_directory)+1);
	strcpy(pathname,sample_directory);
	return pathname;
}

void set_snug_name(int sam_no,char *filename)
{
  register int x;
  register int b = strlen(filename);
	strcpy(song_ptr[sam_no]->title,filename);
  for(x = 0;x < 19;x++)
  {
    if(x < b)
    {
      unsigned char a = filename[x];
      if((a >= 32) && (a <= 127))
        song_ptr[sam_no]->sname[x] = filename[x];
      else
        song_ptr[sam_no]->sname[x] = ' ';
    }
    else
      song_ptr[sam_no]->sname[x] = ' ';
  }
	if (fullpath[sam_no]!=NULL)
		free(fullpath[sam_no]);
	fullpath[sam_no] = set_file_path(sam_no,filename);	
	song_ptr[sam_no]->pathsize = strlen(fullpath[sam_no]) +1;
}

void init_loop_info(tloopinfo *loop)
{
	loop->buf = NULL;
	loop->vol 	= 1.000 ;
	loop->loop = NOLOOP;
	loop->playing = -1;
}


int load_snug(int sam_no,char *filename)
{
	tsong asong;
	if (load_file(filename,&asong) != -1){
		song_ptr[sam_no] = malloc(sizeof(tsong));
		init_loop_info(&asong.loop);
		memcpy(song_ptr[sam_no],&asong,sizeof(tsong));
		set_snug_name(sam_no,filename);
		song_ptr[sam_no]->hk = -1;
		return 0;
	}
	else
		return -1;
}

void curpos_timer(int sig)
{
	long curpos;
  	signal(sig,(void *)&curpos_timer);
	if ((playno <= snug_pos_real + maxy - 4)&&(playno >= snug_pos_real)){
		curpos = ftell(song_ptr[playno]->loop.fp);
		update_curpos(playno, curpos/song_ptr[playno]->info.blkalign);
   		update_pad();
	}
}
void *timer(void *arg)
{
	int no = (int) arg;
  	struct itimerval oldtimer,timer;
	playno = no;
  	signal(SIGALRM,(void *)&curpos_timer);
  	timer.it_value.tv_sec = 0;
  	timer.it_interval.tv_sec = 0;
  	timer.it_value.tv_usec = 50000;
  	timer.it_interval.tv_usec = 50000;
  	setitimer(ITIMER_REAL,&timer,&oldtimer);
	while(1){
		pause();
	}
    return NULL;
}

void *bg_play(void *arg)
{
	int no = (int) arg;
	void clean_up2(void * arg)
	{
		song_ptr[no]->loop.curpos = ftell(song_ptr[no]->loop.fp) /
				song_ptr[no]->info.blkalign;
		pthread_cancel(tid);
		pid = -1;
		update_curpos(no, song_ptr[no]->loop.curpos);
   		update_screen();
	}

	pthread_cleanup_push(clean_up2,NULL);	
	pthread_create(&tid,NULL,timer,(void *)no);
   	player(&song_ptr[no]->info, &song_ptr[no]->loop);
	pthread_cleanup_pop(1);	
    return NULL;
}


void play_file(int no, int hot)
{

	if (song_ptr[no] != NULL){
		if(song_ptr[no]->loop.playing == -1){
			if(pid != -1){
				pthread_cancel(pid);
				pthread_join(pid,NULL);
			}
			//pthread_detach(song->pid);
			//bg_play((void *)no);
			pthread_create(&pid,NULL,bg_play,(void *)no);
		}
		else if (hot == 1) 
			fseek(song_ptr[no]->loop.fp,song_ptr[no]->loop.startpos*
				song_ptr[no]->info.blkalign,SEEK_SET);
		else{
			pthread_cancel(pid);
			pthread_join(pid,NULL);
		}
	}
  	ch = 0;
}

void free_sample(tloopinfo *loop)
{
	free(loop->buf);
	loop->buf = NULL;
}

void *load_ram(tsong *song)
{
	long len, count;
	
	len = ( song->loop.endpos - song->loop.startpos ) *
				song->info.blkalign;

	if ((song->loop.buf = malloc(len)) != NULL){
		fseek(song->loop.fp,song->loop.startpos*song->info.blkalign,SEEK_SET);
		count =  song->loop.read(song->loop.fp,song->loop.buf,len);
		if (count != len){
			free(song->loop.buf);
			song->loop.buf = NULL;
		}
	}
	return song->loop.buf;
}

void save_session(char *filename)
{
  FILE *session;

  void save(void)
  {
    register int x;
	for (x=0;x<=MAX_SONGS;x++){
		if (song_ptr[x] != NULL){
    		fwrite(song_ptr[x],sizeof(tsong),1,session);
			fwrite(fullpath[x],song_ptr[x]->pathsize,1,session);
		}
	}
    return;
  }
  ferr_val = FERR_OK;
  if((session = fopen(filename,"wb")) != NULL)
    {
      save();
      fclose(session);
    }
    else
      ferr_val = FERR_FCREATE;
}

void load_session(int sam_no, char *filename)
{
	
	FILE *session;
	void load(void)
	{
	tsong song;
	
	while(!feof(session)){
    	fread(&song,sizeof(tsong),1,session);
		//path = malloc( path_info.size);
   		fread(sample_directory,song.pathsize ,1,session);
		song.loop.read = NULL;
		if (chdir(sample_directory)!=-1){
			load_snug(sam_no,song.title);
			fseek (song_ptr[sam_no]->loop.fp, song.loop.startpos*song.info.blkalign, SEEK_SET);
			song_ptr[sam_no]->loop.startpos = song.loop.startpos;
			song_ptr[sam_no]->loop.endpos = song.loop.endpos;
			song_ptr[sam_no]->loop.curpos = song.loop.startpos;
			song_ptr[sam_no]->loop.loop = song.loop.loop;
			memcpy(song_ptr[sam_no]->sname,song.sname,20);
			sam_no++;
		}
	}
    return;
	}

  	ferr_val = FERR_OK;
  	if((session = fopen(filename,"rb")) != NULL)
	{
		load();
      	fclose(session);
	}
	else
		ferr_val = FERR_FOPEN;	
}

